<template>
  <div class="w-full flex flex-col gap-2">
    <div class="flex gap-2 items-center">
      <div class="flex-shrink-0">
        <svn-pro-avatar-card :firstname="username" :image="avatar" :type="isAnonymous ? 'anonym' : 'photo'"/>
      </div>

      <div class="flex flex-col justify-center">
        <div class="flex items-center gap-1">
          <Icon
            v-if="isModuleAuthor"
            icon="mingcute:pen-line"
            height="16"
            width="16"
          />

          <svn-pro-subtitle-1-medium :text="username" />
        </div>

        <svn-pro-caption-date-text :text="formattedDate" />
      </div>

      <div class="flex-grow"></div>

      <svn-pro-tooltip v-if="deletable" :text="tooltipText">
        <template #activator="{ props }">
          <svn-pro-icon-button-card-delete
            v-bind="props"
            @click="onDelete"
          />
        </template>
      </svn-pro-tooltip>
    </div>

    <!-- Nouveau conteneur flex pour le gap entre SvnProBodyText et TextButton -->
    <div class="flex flex-col gap-1 items-start">
      <div v-if="commentLoading" class="flex gap-1">
        <div class="animate-[bounce_0.5s_ease-in-out_infinite] rounded-full bg-onSurfaceVariant h-4 w-4" />
        <div class="animate-[bounce_0.75s_ease-in-out_infinite] rounded-full bg-onSurfaceVariant h-4 w-4" />
        <div class="animate-[bounce_1s_ease-in-out_infinite] rounded-full bg-onSurfaceVariant h-4 w-4" />
      </div>

      <svn-pro-body-text v-else :text="comment" />

      <text-button
        v-if="hasCta"
        @click="onClickAppButton"
        :text="replyButtonText"
        variant="text"
        :disabled="false"
      />
    </div>
  </div>
</template>

<script setup>
import { ref, computed, onMounted } from 'vue';
import { Icon } from '@iconify/vue';
import { TextButton } from '../button/buttonComponents';
import { SvnProIconButtonCardDelete } from '../iconButton/SvnProIconButtonComponents';
import moment from 'moment';
import SvnProTooltip from '../tooltip/SvnProTooltip.vue';

import {
  SvnProSubtitle1Medium,
  SvnProCaptionDateText,
  SvnProBodyText,
} from '../text/textComponents';

import { SvnProAvatarCard } from '../avatar/avatarComponents';

const dateObj = ref(null);

const props = defineProps({
  username: {
    type: String,
    default: 'User name',
  },
  avatar: {
    type: String,
    default: undefined,
  },
  date: {
    type: String,
    default: undefined,
  },
  replyButtonText: {
    type: String,
    default: 'Reply',
  },
  tooltipText: {
    type: String,
    default: undefined,
  },
  comment: {
    type: String,
    default:
      'This is a sample comment to display how the text will look within the card.',
  },
  replies: {
    type: Number,
    default: 0,
  },
  deletable: {
    type: Boolean,
    default: false,
  },
  commentLoading: {
    type: Boolean,
    default: false,
  },
  isModuleAuthor: {
    type: Boolean,
    default: false,
  },
  hasCta: {
    type: Boolean,
    default: true,
  },
  isAnonymous: {
    type: Boolean,
    default: false,
  },
});

onMounted(() => {
  if (props.date) {
    const tempDate = moment(props.date);
    dateObj.value = tempDate.isValid() ? tempDate : null;
  }
});

const formattedDate = computed(() => {
  if (!dateObj.value) return '';

  return dateObj.value.format('ddd D MMMM, HH:mm');
});

const emit = defineEmits(['action-clicked', 'delete-clicked']);

const onClickAppButton = () => {
  emit('action-clicked');
};

const onDelete = () => {
  emit('delete-clicked');
};
</script>